|baseNames localEntries currentFiles logFile |
baseNames := #(
 'ACSMsgA'
 'ACSMsgB'
 'ACSMsgC'
 'cheezyBangSyntax'
 'cmCopy'
 'PrivilagedMethods' 
 'removeObsolete'
 'addingPrivilage0' 
 'addingPrivilage'
 'RemoveErrorHandler'
 'forgivingPrims'
 'ObjectInspectorBase'
 'RestrictedProxy'
 'IslandsBase'
 'ParseTreeIteration'
 'instanceVariables'
 'Islands-dynvar1'
 'Islands-dynvar2'
 'Islands-dynvar3'
 'Islands-blocks1'
 'Islands-blocks2'
 'betterFlagInCM'
 'useCMFlag'
 'exceptions1'
 'exceptions2'
 'exceptions3'
 'movePrims1'
 'movePrims2'
 'RestrictedClass'
 'pprintFixup'
 'symbols'
 'symbols2'
 'islands-misc'
 'ANSITime'
 'useTimePlugin'
 'valueWithReceiver'
 'time'
 'time2'
 'immutLits1'
 'immutLits2'
 'cursorRefact1'
 'cursorRefact2'
 'cursorInstallation'
 'cursorInstallation2'
 'colorRefact1'
 'classInitialization'
 'inspectorFixup'
 'criticalUsesEnsure'
 'textStyle1'
 'textStyle2'
 'textStyle3'
 'MorphicSandbox'
 'delaySema1'
 'immutChars'
).

localEntries := FileDirectory default entries.  "compute this in advance--it's slow, at least on Unix"
currentFiles := baseNames collect: [ :baseName |
	| matchingEntries newestEntry |
	matchingEntries := localEntries select: [ :entry | entry isDirectory not and: [ (entry name beginsWith: baseName, '.') ] ].
	matchingEntries isEmpty ifTrue:[ self error: baseName, ' is not present' ].
	newestEntry := matchingEntries detectMax: [ :entry | [(entry name findTokens: '.') reversed second asNumber] ifError: [ :a :b | 0 ] ].
	newestEntry name ].

logFile := FileStream fileNamed: 'loaded.log'.
currentFiles do: [ :file |
	(ChangeSorter changeSetNamed: (file sansPeriodSuffix)) ifNil: [
		"not loaded yet; load it"
		Utilities informUser: file during: [
			logFile nextPutAll: file; cr.
			ChangeSorter newChangesFromStream: (FileStream readOnlyFileNamed: file) named: file. self halt: (file, ' loadod').]. ]. ].